// **********************************************************************
//  PicSignature class definition
//  Part of : PicAlg
// **********************************************************************
// Copyright (C) 1997-1999 PicSearch Team
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version. 
//
// This program is distributed in the hope that it will be useful, 
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
//
// General Public License for more details. 
// You should have received a copy of the GNU General Public License 
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
//
// For any comments please contact: klemstro@cs.helsinki.fi
//
// **********************************************************************

#ifndef PICSIGNATURE_HXX
#define PICSIGNATURE_HXX

#include <pobject.hxx>
#include <bstring.hxx>

/**
  * PicSignature is the base class used for representing signatures of
  * images (or image segments). Each search algorithm library typically 
  * derives a class of its own and translates the binary signature 
  * to/from private representation. Usually each derived class has a 
  * set of private variables which are more handy to use at run-time. 
  **/

class PicSignature
{
	public:

		PicSignature();
		~PicSignature();

		PICULONG creator_id;				// Which algorithm made this?
		PICULONG signature_size;			// Size of the binary
		char *signature;					// Pointer to the actual binary
};

// **********************************************************************

#endif

