// **********************************************************************
//  This file contains PicSegmentAlgorithm implementation
//  Part of : PicAlg
// **********************************************************************
// Copyright (C) 1997 PicSearch Team
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version. 
//
// This program is distributed in the hope that it will be useful, 
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
//
// General Public License for more details. 
// You should have received a copy of the GNU General Public License 
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
//
// For any comments please contact: klemstro@cs.helsinki.fi
//
// **********************************************************************

#include <PicSegmentAlgorithm.hxx>

MAKE_PICABSOBJECTCLASS(PicSegmentAlgorithm, PicObject)

PicSegmentAlgorithm::PicSegmentAlgorithm() :
  id(0), isAutomatic(boolFalse)
{
}

PicObject& PicSegmentAlgorithm::operator = (const PicObject& other)
{
  undefined("PicSegmentAlgorithm::operator =");
  return *this;
}

PICBOOL PicSegmentAlgorithm::operator == (const PicObject& other) const
{
  return (this == &other);
}

PICBOOL PicSegmentAlgorithm::operator <  (const PicObject&) const
{
  undefined("PicSegmentAlgorithm::operator <");
  return boolFalse;
}

PICBOOL PicSegmentAlgorithm::isNull() const
{
  return boolFalse;
}

void PicSegmentAlgorithm::setNull()
{
}

BaseString PicSegmentAlgorithm::getImage() const
{
  return BaseString("name");
}

void PicSegmentAlgorithm::setImage(const BaseString& image)
{
  undefined("PicSegmentAlgorithm::setImage");
}

PICBOOL PicSegmentAlgorithm::setParams(PicIxCollect &params)
{
  getParams(params);
  return boolTrue;
}

PICBOOL PicSegmentAlgorithm::getParams(PicIxCollect &params)
{
  params.setNull();
  return boolTrue;
}

