// **********************************************************************
//  This file contains the main function of PicSearch
//  Part of : PicCore
// **********************************************************************
// Copyright (C) 1997 PicSearch Team
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version. 
//
// This program is distributed in the hope that it will be useful, 
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
//
// General Public License for more details. 
// You should have received a copy of the GNU General Public License 
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
//
// For any comments please contact: klemstro@cs.helsinki.fi
//
// **********************************************************************

#include <mmain.hxx>
#include <perrmgr1.hxx>
#include <penviron.hxx>

int main(int argc, char *argv[])
{
  PicL1ErrorManager errMgr;

  PicMain mainObj;

  if(!PicError::isDetected()){
    if(argc<2){
      static char *newArgv[2];
      static BaseString scriptname = "picsearch.tk";

      argc = 2;
      scriptname.prepend("./source/gui/src/");
      BaseString dirname = PicEnvironment::value("PICSEARCHDIR");
      if(!dirname.isEmpty()){
        scriptname.deleteBefore(2);
        scriptname.prepend(dirname);
      }
      newArgv[0] = "PicSearch";
      newArgv[1] = (char *)scriptname.chars();
      mainObj.startGUI(argc, newArgv);
    }else{
      PICUSHORT i;

//        for(i=1; i<argc; i++){
//          BaseString arg(argv[i]);
//          if(arg == "-reorg"){
//            mainObj.doReorganize();
//          }
//      }
    }
  }
  return 0;
}

