// **********************************************************************
//  This file contains PicSearchType implementation
//  Part of : PicAlg
// **********************************************************************
// Copyright (C) 1997 PicSearch Team
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version. 
//
// This program is distributed in the hope that it will be useful, 
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
//
// General Public License for more details. 
// You should have received a copy of the GNU General Public License 
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
//
// For any comments please contact: klemstro@cs.helsinki.fi
//
// **********************************************************************

#include <picerror.hxx>
#include <searchtype.hxx>
#include <PICServerDataBase.h>

MAKE_PICOBJECTCLASS(PicSearchType, PicObject)

PicSearchType::PicSearchType()
{
}

PicSearchType::PicSearchType(BaseString sTypeName) 
  : name(sTypeName)
{
}

PICBOOL PicSearchType::addAlgorithm(PICDbAlgorithm *alg)
{
  PicErrorContext ecxt;

  if(alg){
    algs.add(alg->name);
  }
  return PicError::isDetected();
}

PicObject& PicSearchType::operator = (const PicObject& other)
{
  undefined("PicSearchType::operator =");
  return *this;
}

PICBOOL PicSearchType::operator == (const PicObject& other) const
{
  return (this == &other);
}

PICBOOL PicSearchType::operator <  (const PicObject&) const
{
  undefined("PicSearchType::operator <");
  return boolFalse;
}

PICBOOL PicSearchType::isNull() const
{
  return(algs.isEmpty() && name.isEmpty());
}

void PicSearchType::setNull()
{
  algs.deleteAll();
  name.setNull();
}

BaseString PicSearchType::getImage() const
{
  return name;
}

void PicSearchType::setImage(const BaseString& image)
{
  undefined("PicSearchType::setImage");
}

