// --------------------------------------------------------------------------
//  STRING ARRAY
//  Part of : PicLib
// --------------------------------------------------------------------------
// Copyright (C) 1997 PicSearch Team
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version. 
//
// This program is distributed in the hope that it will be useful, 
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
//
// General Public License for more details. 
// You should have received a copy of the GNU General Public License 
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
//
// For any comments please contact: klemstro@cs.helsinki.fi
//
// --------------------------------------------------------------------------

// Edit these defines
// -------------------------
#ifndef BSTRARR_HXX
#define BSTRARR_HXX
// -------------------------

#ifdef ITEM_CLASS
#undef ITEM_CLASS
#endif

#ifdef ITEM_CLASS_ARRAY
#undef ITEM_CLASS_ARRAY
#endif

#ifdef ITEM_CLASS_ARRAY_NAME
#undef ITEM_CLASS_ARRAY_NAME
#endif

// Edit these defines
// -------------------------------------------------
#define ITEM_CLASS            BaseString
#define ITEM_CLASS_ARRAY      BaseStringArray
#define ITEM_CLASS_ARRAY_NAME "BaseStringArray"
// -------------------------------------------------

/*:descr ************************************************************

BaseStringArray is a collection of BaseStrings.
class BaseStringArray : public BaseCollection{ ... };

:see BaseCollection

****************************************************************************/

// Edit this include
// ----------------------
#include <bstring.hxx>
// ----------------------
class PicCollection;

#include <genarr1.hgn>

    PICBOOL     putAt (PICPOSITION, const BaseString&);
    PICPOSITION addAt (PICPOSITION, const BaseString&);
    PICPOSITION add   (const BaseString&);

    PICBOOL     putAt (PICPOSITION, const char*);
    PICPOSITION addAt (PICPOSITION, const char*);
    PICPOSITION add   (const char*);

    PICBOOL     add   (const PicCollection&);

#include <genarr2.hgn>

// --------------------------------------------------------------------------
//      ADDITIONAL INLINE DEFINITIONS

inline PICBOOL BaseStringArray::putAt (PICPOSITION pos, const BaseString& item)
       { return put(pos) ? (at(pos) = item, boolTrue) : boolFalse; }

inline PICPOSITION BaseStringArray::addAt (PICPOSITION pos, const BaseString& item)
       { return (pos = insert(pos)) ? (at(pos) = item, pos) : 0; }

inline PICPOSITION BaseStringArray::add (const BaseString& item)
       { PICPOSITION pos; return (pos = insert()) ? (at(pos) = item, pos) : 0; }

inline PICBOOL BaseStringArray::putAt (PICPOSITION pos, const char* item)
       { return put(pos) ? (at(pos) = item, boolTrue) : boolFalse; }

inline PICPOSITION BaseStringArray::addAt (PICPOSITION pos, const char* item)
       { return (pos = insert(pos)) ? (at(pos) = item, pos) : 0; }

inline PICPOSITION BaseStringArray::add (const char* item)
       { PICPOSITION pos; return (pos = insert()) ? (at(pos) = item, pos) : 0; }

#endif
