// --------------------------------------------------------------------------
//  INDEX-OBJECT ASSOCIATION ARRAY
//  Part of : PicLib
// --------------------------------------------------------------------------
// Copyright (C) 1997 PicSearch Team
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version. 
//
// This program is distributed in the hope that it will be useful, 
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
//
// General Public License for more details. 
// You should have received a copy of the GNU General Public License 
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
//
// For any comments please contact: klemstro@cs.helsinki.fi
//
// --------------------------------------------------------------------------

// Edit these defines:
// -------------------
#ifndef PICASSOC_ARRAY_HXX
#define PICASSOC_ARRAY_HXX

#ifdef ITEM_CLASS
#undef ITEM_CLASS
#endif

#ifdef ITEM_CLASS_ARRAY
#undef ITEM_CLASS_ARRAY
#endif

#ifdef ITEM_CLASS_ARRAY_NAME
#undef ITEM_CLASS_ARRAY_NAME
#endif

// Edit these defines:
// -------------------
#define ITEM_CLASS             PicAssoc
#define ITEM_CLASS_ARRAY       PicAssocArray
#define ITEM_CLASS_ARRAY_NAME  "PicAssocArray" 

/*:descr ************************************************************

PicAssocArray is a collection of PicAssoc:s.
class PicAssocArray : public BaseCollection{ ... };

:see BaseCollection

****************************************************************************/

// Edit this include:
// ------------------
#include <passoc.hxx>

#include <genarr1.hgn>

// --------------------------------------------------------------------------
//
//      replace     Replaces the object at the given index returning
//                  the old one.
//      locationOf  Returns the location of the given index or object
//                  in the association array (the first one found). If
//                  not found, zero is returned.
//      locationFor Same as locationOf, but if it doesn't find the index, it
//                  returns the first free index (or zero, if there
//                  are no free indexes available).
//      equals      Returns boolTrue if the arrays contain same associations
//                  in the same order.

    PicObject* replace (PICPOSITION loc, PicObject*);

    PICPOSITION locationOf  (PICINDEX) const;
    PICPOSITION locationOf  (const PicObject&) const;
    PICPOSITION locationFor (PICINDEX);

//    typedef PICBOOL COMPARE_ASSOC_PROC (
//        const PicAssoc&, const PicAssoc&) const;

    PICBOOL equals (const PicAssocArray&) const;

// --------------------------------------------------------------------------

#include <genarr2.hgn>

inline PicObject* PicAssocArray::replace (PICPOSITION loc, PicObject* pobj)
{
    THIS[loc].swapObject(pobj);
    return pobj;
}

#endif
