// --------------------------------------------------------------------------
//  INDEX-OBJECT ASSOCIATION implementation
//  Part of : PicLib
// --------------------------------------------------------------------------
// Copyright (C) 1997 PicSearch Team
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version. 
//
// This program is distributed in the hope that it will be useful, 
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
//
// General Public License for more details. 
// You should have received a copy of the GNU General Public License 
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
//
// For any comments please contact: klemstro@cs.helsinki.fi
//
// --------------------------------------------------------------------------

#include <passoc.hxx>
#include <bstring.hxx>
#include <pobject.hxx>

MAKE_PICCLASS(PicAssoc)

// --------------------------------------------------------------------------
//      CONSTRUCTORS, DESTRUCTOR & ASSIGNMENT

PicAssoc::~PicAssoc ()
{
    if (obj)
        delete obj;
}

PicAssoc::PicAssoc (const PicAssoc& assoc)
 : ind(assoc.ind), obj(assoc.obj ? assoc.obj->copy() : NULLPTR) {}

PicAssoc& PicAssoc::operator = (const PicAssoc& assoc)
{
    ind = assoc.ind;
    obj = assoc.obj ? assoc.obj->copy() : NULLPTR;
    return *this;
}

// --------------------------------------------------------------------------
//      EQUALITY COMPARISON

PICBOOL PicAssoc::operator == (const PicAssoc& ass) const
{
    // Both are nulls, or both contain equal indexes & objects
    return (!obj && !ass.obj) ||
           (ind == ass.ind && obj && ass.obj && *obj == *ass.obj);
}

// --------------------------------------------------------------------------
//      NULL ASSOCIATION

void PicAssoc::setNull ()
{
    if (obj)
        delete obj;
    obj = NULLPTR;
    ind = 0;
}

