// --------------------------------------------------------------------------
//  CHARACTER implementation
//  Part of : PicLib
// --------------------------------------------------------------------------
// Copyright (C) 1997 PicSearch Team
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version. 
//
// This program is distributed in the hope that it will be useful, 
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
//
// General Public License for more details. 
// You should have received a copy of the GNU General Public License 
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
//
// For any comments please contact: klemstro@cs.helsinki.fi
//
// --------------------------------------------------------------------------

extern "C" {
#include <ctype.h>
#include <string.h>
}

#include <pchar.hxx>
#include <picerror.hxx>

const PICUSHORT maxCharacter   =  255;
const PICFLAG   classUppercase = 0x01;
const PICFLAG   classLowercase = 0x02;
const PICFLAG   classSpace     = 0x04;
const PICFLAG   classDigit     = 0x08;

MAKE_PICCLASS(PicChar)

// --------------------------------------------------------------------------
//      CLASSIFICATION

char PicChar::uppercase (char ch)
{
    return (char)toupper(ch);
}

char PicChar::lowercase (char ch)
{
    return (char)tolower(ch);
}

PICBOOL PicChar::isUppercase (char ch)
{
    return isupper(ch);
}

PICBOOL PicChar::isLowercase (char ch)
{
    return islower(ch);
}

PICBOOL PicChar::isAlphabetic (char ch)
{
    return isalpha(ch);
}

PICBOOL PicChar::isAlphanumeric (char ch)
{
    return isalnum(ch);
}

PICBOOL PicChar::isDigit (char ch)
{
    return isdigit(ch);
}

PICBOOL PicChar::isSpace (char ch)
{
    return isspace(ch);
}

PicCompareResult PicChar::caseCompare (char ch1, char ch2)
{
    char str1[2] = "x", str2[2] = "x";
    str1[0] = ch1;
    str2[0] = ch2;
    int diff = strcmp(str1, str2);
    if (diff == 0)
        return isEqual;
    else if (diff < 0)
        return isLess;
    return isGreater;
}

PicCompareResult PicChar::compare (char ch1, char ch2)
{
    char str1[2] = "x", str2[2] = "x";
    str1[0] = toupper(ch1);
    str2[0] = toupper(ch2);
    int diff = strcmp(str1, str2);
    if (diff == 0)
        return isEqual;
    else if (diff < 0)
        return isLess;
    return isGreater;
}

