// **********************************************************************
//  Search algorithm : Name & description algorithm
//  Part of : PicAlg
// **********************************************************************
// Copyright (C) 1997 PicSearch Team
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or 
// (at your option) any later version. 
//
// This program is distributed in the hope that it will be useful, 
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
//
// General Public License for more details. 
// You should have received a copy of the GNU General Public License 
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 
//
// For any comments please contact: klemstro@cs.helsinki.fi
//
// **********************************************************************

#ifndef PICNAMEALG_HXX
#define PICNAMEALG_HXX

#include <PicLibAlgorithm.hxx>

/**
  * Name search algorithm implements a simple searching by image's name.
  **/
  
PICBOOL       useName, usePar1, usePar2;
BaseString    imName, par1, par2;

class PicNameAlgSignature : public PicSignature
{
 public:

  /**
    * The default constructor.
    **/
  PicNameAlgSignature();
  /**
    * Constructor which sets the signature data.
    *
    * @param newName Picture name.
    * @param newPar1 Picture parameter string 1.
    * @param newPar2 Picture parameter string 2.
    **/
  PicNameAlgSignature(BaseString newName, BaseString newPar1, BaseString newPar2);

  PicNameAlgSignature(PicSignature *from);
  
  /**
    * The destructor.
    **/
  ~PicNameAlgSignature();

  int sigFailure;

  private:
	BaseString    imName, par1, par2;

  friend class PicLibAlgorithm;
};

#endif
