// **********************************************************************
//
//      PICNet.h
//
// **********************************************************************
// Copyright (C) 1997 PicSearch Team
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
//
// General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
// For any comments please contact: klemstro@cs.helsinki.fi
//
// **********************************************************************    

#ifndef PICNET_H_
#define PICNET_H_ 

#define MAX_PORT		65535    // the largest port number
#define MAX_OPEN_FILES		5	// max open files of waiting in one connection
#define HOST_PORT		10000

#include <iostream.h> 
#include <string.h>       
#include <stdio.h>
#include <stdlib.h>      // read, write
#include <netinet/in.h>  // htonl, ntohl 
#include <unistd.h>
#include <fcntl.h> 
#include <sys/time.h>
#include <netdb.h>       // gethostbyname() 
#include <arpa/inet.h>   // inet_addr()
#include <sys/types.h>   // socket(), bind(), connect() 
#include <sys/socket.h>  // socket(), bind(), connect(), inet_addr() 
#include <errno.h>

/**
 * The PICNet class.
 * This class can be used to establish and to close down a connection between 
 * one or many clients and a server. It also support methods for transferring
 * data.
 *
 * @version 0.1
 * author Timo Virtanen
 * @version 0.1.3
 * revised by SP
 **/

class PICNet
{
public:
  PICNet(){ }
  ~PICNet();
  void ReadSome();

  bool CheckSocket(int sec);
  bool HostSocketInit(int portNumber);
  bool ClientSocketInit(char *hostName, int portNumber);
  bool AcceptClientRequest();
  void CloseHostSocket();
  void CloseServerSocket(); 

  int serverSocketID(void);

protected:
  // The socket the host is connected to.
  int   hostSocket;
  // The socket between the server and the client.
  int   serverSocket; 
  /// The socket data structure of the host.
  struct sockaddr_in  mySockAdr;           
};

#endif // PICNET_H_
