#ifndef PICDEBUG_H_
#define PICDEBUG_H_

#include <iostream.h>
#include <unistd.h> // for getpid()

#ifdef DEBUG_MODE
#include <assert.h>
#define DEBUG_MSG(msg) { cout<<"("<<getpid()<<") "<<msg; }
#define ASSERT(cond) { assert(cond); }
#else //DEBUG_MODE
#define DEBUG_MSG(msg) ;
#define ASSERT(cond) ;
#endif //DEBUG_MODE

#ifdef LOG_MODE
#include <fstream.h>
#define LOG_FILE "pserver.log"
#define LOG_MSG(msg) { \
  DEBUG_MSG (msg); \
  fstream log( LOG_FILE, ios::app | ios::ate ); \
  log << "(" << getpid() << ")" << msg; \
  log.close(); \
}
#define RESET_LOG { \
  fstream log( LOG_FILE, ios::app | ios::trunc ); \
  log.close(); \
}
#else //LOG_MODE
#define LOG_MSG(msg) ;
#define RESET_LOG ;
#endif LOG_MODE

#define ERROR_MSG(msg) { cerr<<"("<<getpid()<<") "<<msg; LOG_MSG(msg); }

#endif //PICDEBUG_H_
