// **********************************************************************
//
//      Options.cpp
//
// **********************************************************************
// Copyright (C) 1997 PicSearch Team
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
//
// General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
// For any comments please contact: klemstro@cs.helsinki.fi
//
// **********************************************************************

#include <iostream.h>
#include <PICDebug.h>
#include <PICNet.h>
#include <PICServer.h>

void PICServer::SendOptions(void) {
  DEBUG_MSG("[SRV] sending options\n");
  servOpts_msg msg;

  string http=DB.params["host"].http;
  string info=DB.params["host"].info;
  string maxclients=itos(DB.params["host"].maxclients);
  string timeout=itos(DB.params["host"].timeout);

  msg.opts.opts_len=4;
  msg.opts.opts_val=new namedValue[msg.opts.opts_len];

  msg.opts.opts_val[0].name="http";
  msg.opts.opts_val[0].value=(char *)http.c_str();
  msg.opts.opts_val[1].name="info";
  msg.opts.opts_val[1].value=(char *)info.c_str();
  msg.opts.opts_val[2].name="maxclients";
  msg.opts.opts_val[2].value=(char *)maxclients.c_str();
  msg.opts.opts_val[3].name="timeout";
  msg.opts.opts_val[3].value=(char *)timeout.c_str();

  xdrH->send(&msg);
  LOG_MSG("[SRV] server options message sent\n");
}

void PICServer::SetOptions(setServOpt_msg &msg) {
  DEBUG_MSG("[SRV] setting options\n");

  for(unsigned int optc=0;optc<msg.opts.opts_len;++optc) {
    if(strcmp(msg.opts.opts_val[optc].name,"http")==0) {
      DB.params["host"].http=msg.opts.opts_val[optc].value;
    } else if(strcmp(msg.opts.opts_val[optc].name,"info")==0){
      DB.params["host"].info=msg.opts.opts_val[optc].value;
    } else if(strcmp(msg.opts.opts_val[optc].name,"maxclients")==0){
      DB.params["host"].maxclients=atoi(msg.opts.opts_val[optc].value);
    } else if(strcmp(msg.opts.opts_val[optc].name,"timeout")==0){
      DB.params["host"].timeout=atoi(msg.opts.opts_val[optc].value);
    } else {
      DEBUG_MSG("received unknown option " << msg.opts.opts_val[optc].name <<
		". ignoring." << endl);
    }
  }
  SendComplete();
}


