#include<string>
#include<iostream.h>
#include<fstream.h>
#include<list>
#include<ctype.h>
#include<string.h>
//#include<stdlib.h>

//#define DEBUGMODE
#define SAFEMODE
//#define VERBOSE

string getNextString(istream& is); //get next ws-delimited string.

list<string> typeNames;
char *inFName    = "messages",
     *typeFName  = "msgtype.x",
     *typeHFName = "msgtype.h",
     *messHFName = "mess.h",
     *messFName  = "mess.cpp",
     *messInclude= "message.h";

string disclaimer = 
"/*\n"
" * This file was generated by msggen, a crappy little prog to generate\n"
" * C++ wrappers for simple xdr structures for use in picsearch. It'll do\n"
" * you no good whatsoever to edit it, so be my guest. [SP]\n"
" */\n\n";

void readTypes(const char *fName) {
  ifstream is(fName);
  string name;

  if(!is) {
    cerr << "couldn't open " << fName << endl;
    exit(1);
  }

  while((name=getNextString(is))!="") {
    typeNames.push_back(name);
  }
}

void writeTypes(const char *fName) {
  ofstream types(fName);

  if(!types) {
    cerr << "couldn't open " << fName << endl;
    exit(1);
  }

  types << disclaimer;

  types << "/* BTW. this is a rpc .x file. Use rpcgen on it. */\n\n";

  types << "enum MessageType {";
  bool first=true;
  for(list<string>::iterator i=typeNames.begin();i!=typeNames.end();++i) {
    if(!first) 
      types << ",";
    first=false;
    
    types << endl << "  msg_" << *i;
  }
  types << endl << "};" << endl;
}

string messhStart =
"typedef int (*rwfun)(char *, char *, int);\n\n"
#ifdef DEBUGMODE
"ssize_t Read(int fd, void *ptr, size_t nbytes);\n"
"ssize_t Write(int fd, void *ptr, size_t nbytes);\n\n"
#endif
"class xdrHandler {\n"
"  XDR xdrHandle;\n"
"  MessageType msgType;\n"
"  bool typeValid;\n"
"  bool nextType(MessageType *type);\n"
" public:\n"
"  xdrHandler(int connfd) : msgType(MessageType(0)), typeValid(false) {\n"
#ifdef DEBUGMODE
"    xdrrec_create(&xdrHandle,0,0,(caddr_t)connfd,(rwfun)Read,(rwfun)Write);\n"
#else
"    xdrrec_create(&xdrHandle,0,0,(caddr_t)connfd,(rwfun)read,(rwfun)write);\n"
#endif
"  }\n"
"  ~xdrHandler(void) {\n"
"    xdr_destroy(&xdrHandle);\n"
"  }\n"
"  MessageType currentMessage(void);\n"
"  void proceed(void);\n";

void writeMessHeader(const char *fName) {
  ofstream messh(fName);

  if(!messh) {
    cerr << "couldn't open " << fName << endl;
    exit(1);
  }

  messh << disclaimer;

  messh << "#ifndef _MESS_H_MSGGEN" << endl;
  messh << "#define _MESS_H_MSGGEN" << endl << endl;

  messh << "#include<rpc/xdr.h>" << endl;
  messh << "#include<unistd.h>" << endl << endl;
  messh << "#include\"" << typeHFName << "\"" << endl << endl;

  messh << "/* start forward delarations */" << endl;
  for(list<string>::iterator i=typeNames.begin();i!=typeNames.end();++i) {
    messh << "struct " << *i << "_msg;" << endl;
  }
  messh << "/* end forward declarations */" << endl << endl;

  messh << messhStart;
  
  messh << "  /* start send functions */" << endl;
  for(list<string>::iterator i=typeNames.begin();i!=typeNames.end();++i) {
    messh << "  bool send(" << *i << "_msg *);" << endl;
  }
  messh << "  /* end send functions */" << endl << endl;

  messh << "  /* start receive functions */" << endl;
  for(list<string>::iterator i=typeNames.begin();i!=typeNames.end();++i) {
    messh << "  bool receive(" << *i << "_msg *);" << endl;
  }
  messh << "  /* end receive functions */" << endl << endl;

  messh << "  /* start free functions */" << endl;
  for(list<string>::iterator i=typeNames.begin();i!=typeNames.end();++i) {
    messh << "  void free(" << *i << "_msg *);" << endl;
  }
  messh << "  /* end free functions */" << endl;
  
  messh << "};" << endl << endl;

  messh << "#endif /* !_MESS_H_MSGGEN */" << endl;
}

string messFStart = 
#ifdef SAFEMODE
"#include<string.h> /* for memset */\n\n"
#endif /* SAFEMODE */
#ifdef DEBUGMODE
"ssize_t Read(int fd, void *ptr, size_t nbytes) {\n"
"  ssize_t n;\n"
"  static bool printDebug=0;\n"
"\n"
"  if(printDebug)\n"
"    printf(\"Read with %d bytes and fd %d\\n\",nbytes,fd);\n"
"  if ( (n = read(fd, ptr, nbytes)) == -1)\n"
"    printf(\"read error\\n\");\n"
"  printDebug = (n!=0);\n"
"  if(printDebug)\n"
"    printf(\"Read %d bytes, returning\\n\",n);\n"
"  return(n);\n"
"}\n"
"\n"
"ssize_t Write(int fd, void *ptr, size_t nbytes) {\n"
"  printf(\"Write with %d bytes and fd %d\\n\",nbytes,fd);\n"
"  if (write(fd, ptr, nbytes) != (ssize_t)nbytes)\n"
"    printf(\"write error\\n\");\n"
"  printf(\"Wrote %d bytes, returning\\n\",nbytes);\n"
"  return nbytes;\n"
"}\n\n"
#endif /* DEBUGMODE */
"bool xdrHandler::nextType(MessageType *type) {\n"
"  xdrHandle.x_op=XDR_DECODE;\n"
#ifdef VERBOSE
"  cout << \"[xdrH] nextType\" << endl;\n"
#endif /* VERBOSE */
#ifdef SAFEMODE
"  memset(type,0,sizeof(MessageType));\n"
#endif /* SAFEMODE */
"  if(!xdrrec_skiprecord(&xdrHandle)) {\n"
#ifdef VERBOSE
"    cout << \"[xdrH] nextType: xdrrec_skiprecord failure!\" << endl;\n"
#endif /* VERBOSE */
"    return false;\n"
"  }\n"
"  return xdr_MessageType(&xdrHandle,type);\n"
"}\n\n"
"MessageType xdrHandler::currentMessage(void) {\n"
#ifdef VERBOSE
"  cout << \"[xdrH] currentMessage\" << endl;\n"
#endif /* VERBOSE */
"  if(!typeValid) {\n"
#ifdef VERBOSE
"    cout << \"[xdrH] currentMessage: !typeValid\" << endl;\n"
#endif /* VERBOSE */
"    typeValid=nextType(&msgType);\n"
#ifdef VERBOSE
"    cout << \"[xdrH] currentMessage: typeValid==\" << typeValid << endl;\n"
#endif /* VERBOSE */
"  }\n"
#ifdef VERBOSE
"  cout << \"[xdrH] currentMessage: returning \" << msgType << endl;\n"
#endif VERBOSE
"  return msgType;\n"
"}\n\n"
"void xdrHandler::proceed(void) {\n"
#ifdef VERBOSE
"  cout << \"[xdrH] proceed\" << endl;\n"
#endif /* VERBOSE */
"  typeValid=false; /* next read will get next message */\n"
"}\n\n";

void writeMessFile(const char *fName) {
  ofstream messf(fName);

  if(!messf) {
    cerr << "couldn't open " << fName << endl;
    exit(1);
  }

  messf << disclaimer;
#ifdef VERBOSE
  messf << "#include<iostream>" << endl;
#endif /* VERBOSE */
  messf << "#include\"" << messHFName << "\"" << endl;
  messf << "#include\"" << messInclude<< "\"" << endl;
  messf << "#include\"" << typeHFName << "\"" << endl << endl;

  messf << messFStart;
  
  messf << "/* start send functions */" << endl << endl;
  for(list<string>::iterator i=typeNames.begin();i!=typeNames.end();++i) {
    messf << "bool xdrHandler::send(" << *i << "_msg *msg) {"<< endl;
#ifdef VERBOSE
    messf << "  cout << \"[xdrH] send " << *i << "\" << endl;"<<endl;
#endif /* VERBOSE */
    messf << "  MessageType type=msg_"  << *i << ";" << endl << endl;
    messf << "  xdrHandle.x_op=XDR_ENCODE;"                  << endl;
    messf << "  return(xdr_MessageType(&xdrHandle,&type) &&" << endl;
    messf << "         xdr_"<< *i<<"_msg(&xdrHandle,msg) &&" << endl;
    messf << "         xdrrec_endofrecord(&xdrHandle,true));"<< endl;
    messf << "}" << endl << endl;
  }
  messf << "/* end send functions */" << endl << endl;

  messf << "/* start receive functions */" << endl << endl;
  for(list<string>::iterator i=typeNames.begin();i!=typeNames.end();++i) {
    messf << "bool xdrHandler::receive(" << *i << "_msg *msg) {" << endl;
#ifdef VERBOSE
    messf << "  cout << \"[xdrH] reveive " << *i << "\" << endl;"<< endl;
#endif /* VERBOSE */
    messf << "  xdrHandle.x_op=XDR_DECODE;"                      << endl;
    messf << "  if(currentMessage()!=msg_" << *i << ")"          << endl;
    messf << "    return false;"                                 << endl;
#ifdef SAFEMODE
    messf << "  memset(msg,0,sizeof(" << *i <<"_msg));"          << endl;
#endif /* SAFEMODE */
    messf << "  proceed(); /* nextx read will get next msg */"   << endl;   
    messf << "  return(xdr_" << *i << "_msg(&xdrHandle,msg));"   << endl;
    messf << "}"                                         << endl << endl;
  }
  messf << "/* end receive functions */" << endl << endl;

  messf << "/* start free functions */" << endl << endl;
  for(list<string>::iterator i=typeNames.begin();i!=typeNames.end();++i) {
    messf << "void xdrHandler::free(" << *i << "_msg *msg) {" << endl;
#ifdef VERBOSE
    messf << "  cout << \"[xdrH] free " << *i << "\" << endl;"<< endl;
#endif /* VERBOSE */
    messf << "  xdr_free((xdrproc_t)xdr_"<< *i<<"_msg,(char *)msg);" << endl;
    messf << "}"                                             << endl << endl;
  }
  messf << "/* end free functions */" << endl << endl;
}

char *makeTypeHFName(string tFName) {
  int i;
  string tHFName="";

  for(i=tFName.length()-1;i>=0 && tFName[i]!='.';--i);

  if(i<0) { //no period, just append ".h".
    tHFName=tFName + ".h";
  } else {  //there is a period at i, take substring and append ".h".
    tHFName=string(tFName,0,i) + ".h";
  }
  return strdup(tHFName.c_str());
}

main(int argc,char *argv[]) {

  switch(argc) {
  case 6: messInclude= argv[5];
  case 5: messFName  = argv[4];
  case 4: messHFName = argv[3];
  case 3: typeFName  = argv[2]; 
          typeHFName = makeTypeHFName(argv[2]);
  case 2: inFName    = argv[1];
  }

  //cout << "attempting to process file \"" << inFName << "\"" << endl;
  //cout << "to generate type file \"" << typeFName << "\"," << endl;
  //cout << "message header file \"" << messHFName << "\"" << endl;
  //cout << "and message file \"" << messFName << "\"." << endl;

  readTypes(inFName);
  writeTypes(typeFName);
  writeMessHeader(messHFName);
  writeMessFile(messFName);
}

istream& skipSpace(istream& is) {   //removes space from an istream.
  char c;

  while(is.get(c)) {
    if(!isspace(c)) {
      is.putback(c);
      break;
    }
  }
  return is;
}

#define MAXLINE 1024

string getNextString(istream& is) {
  char buf[MAXLINE];

  while(skipSpace(is)) {
    is.getline(buf,MAXLINE);
    int len=is.gcount();

    if(len==0) //this would mean an error, but check anyways.
      return "";

    if(buf[0]=='#') //I'll consider this a comment.
      continue;

    int size;
    for(size=0;size<len && !isspace(buf[size]);++size);

    return string(&buf[0],size-1);  
  }
  return "";
}

